Package org.eclipse.net4j.util.ref

## Class ReferenceValueMap<K,​V>

- java.lang.Object
- - java.util.AbstractMap<K,​V>
  - - org.eclipse.net4j.util.ref.ReferenceValueMap2<K,​V>
    - - org.eclipse.net4j.util.ref.ReferenceValueMap<K,​V>

- All Implemented Interfaces:
    `java.util.concurrent.ConcurrentMap<K,​V>`, `java.util.Map<K,​V>`
  Direct Known Subclasses:
    `ReferenceValueMap.Soft`, `ReferenceValueMap.Strong`, `ReferenceValueMap.Weak`

      public abstract class ReferenceValueMap<K,​V>
      extends ReferenceValueMap2<K,​V>
      implements java.util.concurrent.ConcurrentMap<K,​V>

  A `ConcurrentMap` implementation that uses `KeyedReference` instances (`KeyedStrongReference`, `KeyedSoftReference`, `KeyedWeakReference` or `KeyedPhantomReference`) as its values.

  A `ReferenceValueMap` can be used to cache mappings until the value of the mapping is no longer reachable from outside of the map

  Note: This map is not synchronized. If it is to be used by multiple threads concurrently the user is responsible for applying proper external synchronization!

  Author:
    Eike Stepper

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `static class` | `ReferenceValueMap.Soft<K,​V>` |
    `static class` | `ReferenceValueMap.Strong<K,​V>` |
    `static class` | `ReferenceValueMap.Weak<K,​V>` |

    - ### Nested classes/interfaces inherited from class java.util.AbstractMap

      `java.util.AbstractMap.SimpleEntry<K extends java.lang.Object,​V extends java.lang.Object>, java.util.AbstractMap.SimpleImmutableEntry<K extends java.lang.Object,​V extends java.lang.Object>`

    - ### Nested classes/interfaces inherited from interface java.util.Map

      `java.util.Map.Entry<K extends java.lang.Object,​V extends java.lang.Object>`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ReferenceValueMap()` |
    `ReferenceValueMap​(java.util.concurrent.ConcurrentMap<K,​KeyedReference<K,​V>> map)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `V` | `putIfAbsent​(K key, V value)` |
    `boolean` | `remove​(java.lang.Object key, java.lang.Object value)` |
    `V` | `replace​(K key, V value)` |
    `boolean` | `replace​(K key, V oldValue, V newValue)` |

    - ### Methods inherited from class org.eclipse.net4j.util.ref.ReferenceValueMap2

      `clear, containsKey, containsValue, createQueue, createReference, dereference, entrySet, get, internalPurgeQueue, isEmpty, purged, purgeQueue, put, remove, size`

    - ### Methods inherited from class java.util.AbstractMap

      `clone, equals, hashCode, keySet, putAll, toString, values`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.util.concurrent.ConcurrentMap

      `compute, computeIfAbsent, computeIfPresent, forEach, getOrDefault, merge, replaceAll`

    - ### Methods inherited from interface java.util.Map

      `clear, containsKey, containsValue, entrySet, equals, get, hashCode, isEmpty, keySet, put, putAll, remove, size, values`

- - ### Constructor Detail

    - #### ReferenceValueMap

          public ReferenceValueMap()

    - #### ReferenceValueMap

          public ReferenceValueMap​(java.util.concurrent.ConcurrentMap<K,​KeyedReference<K,​V>> map)

  - ### Method Detail

    - #### putIfAbsent

          public V putIfAbsent​(K key,
                               V value)

      Specified by:
        `putIfAbsent` in interface `java.util.concurrent.ConcurrentMap<K,​V>`
      Specified by:
        `putIfAbsent` in interface `java.util.Map<K,​V>`

    - #### replace

          public V replace​(K key,
                           V value)

      Specified by:
        `replace` in interface `java.util.concurrent.ConcurrentMap<K,​V>`
      Specified by:
        `replace` in interface `java.util.Map<K,​V>`

    - #### replace

          public boolean replace​(K key,
                                 V oldValue,
                                 V newValue)

      Specified by:
        `replace` in interface `java.util.concurrent.ConcurrentMap<K,​V>`
      Specified by:
        `replace` in interface `java.util.Map<K,​V>`

    - #### remove

          public boolean remove​(java.lang.Object key,
                                java.lang.Object value)

      Specified by:
        `remove` in interface `java.util.concurrent.ConcurrentMap<K,​V>`
      Specified by:
        `remove` in interface `java.util.Map<K,​V>`